/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.modules.ycwh.service.impl;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springblade.core.mp.base.BaseServiceImpl;
import org.springblade.core.tool.utils.Func;
import org.springblade.modules.ycwh.entity.LikeInfoEntity;
import org.springblade.modules.ycwh.enums.ArticleTypeEnum;
import org.springblade.modules.ycwh.mapper.LikeInfoMapper;
import org.springblade.modules.ycwh.service.ILikeInfoService;
import org.springblade.modules.ycwh.vo.LikeInfoVO;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 名菜名点名店收藏 服务实现类
 *
 * @author BladeX
 * @since 2023-08-29
 */
@Service
public class LikeInfoServiceImpl extends BaseServiceImpl<LikeInfoMapper, LikeInfoEntity> implements ILikeInfoService {

	@Override
	public IPage<LikeInfoVO> selectLikeInfoPage(IPage<LikeInfoVO> page, LikeInfoVO likeInfo) {
		return page.setRecords(baseMapper.selectLikeInfoPage(page, likeInfo));
	}

	@Override
	public Boolean checkHasLiked(Long memberId, ArticleTypeEnum articleType, Long articleId) {
		LambdaQueryWrapper<LikeInfoEntity> lqw = new LambdaQueryWrapper();
		lqw.eq(LikeInfoEntity::getMemberId, memberId);
		lqw.eq(LikeInfoEntity::getLikeType, articleType.getKey());
		lqw.eq(LikeInfoEntity::getLikeId, articleId);
		lqw.last("LIMIT 1");
		return Func.isNotEmpty(this.getOne(lqw));
	}

	@Override
	public Long countLikeNum(ArticleTypeEnum articleType, Long articleId) {
		LambdaQueryWrapper<LikeInfoEntity> lqw = new LambdaQueryWrapper();
		lqw.eq(LikeInfoEntity::getLikeType, articleType.getKey());
		lqw.eq(LikeInfoEntity::getLikeId, articleId);
		return this.count(lqw);
	}


}
